import win32.windows;
import win32.commctrl;
import std.stdio;
import std.string;
import std.utf;
import win32frame.writek;
import win32frame.WindowObject ;
import win32frame.ToolBarEx ;
import win32frame.CommonControlEx;


class Rebar : WindowObject {
  REBARINFO     rebarinfo ;
  REBARBANDINFO rbbinfo ;
  int cx=0 ;

  this(string name) {
    CommonControlEx ccex = new CommonControlEx(ICC_BAR_CLASSES | ICC_COOL_CLASSES) ;
    winc.lpszClassName  = toUTFz!(wchar*)(REBARCLASSNAME) ;
    setExStyle( WS_EX_TOOLWINDOW ) ;

    //    setExStyle( WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | RBS_BANDBORDERS | WS_CLIPCHILDREN | CCS_NODIVIDER | CCS_LEFT ) ;
    setStyle(  (WS_CAPTION | WS_BORDER | WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN | WS_CLIPSIBLINGS | RBS_VARHEIGHT |RBS_BANDBORDERS | CCS_NODIVIDER | CCS_NOPARENTALIGN) ) ;

    rebarinfo.cbSize = REBARINFO.sizeof ;
    rebarinfo.fMask  = 0 ;
    rebarinfo.himl   = null ;

    rbbinfo.cbSize     = REBARBANDINFO.sizeof ;
    rbbinfo.fMask      = RBBIM_BACKGROUND | RBBIM_STYLE | RBBIM_CHILD | RBBIM_CHILDSIZE | RBBIM_SIZE ;
    rbbinfo.cxMinChild = 100 ;
    rbbinfo.cyMinChild = 25 ;
    rbbinfo.cx         = 128 ;

    super(name) ;
  }

  int setREBARBANDINFO(REBARBANDINFO rbbi){
    rbbinfo        = rbbi ;
    rbbinfo.cbSize = REBARBANDINFO.sizeof ;
    return(0) ;
  }

  int addTool(ToolBarEx toolbar){
    REBARBANDINFO rbbi ;
    RECT rc ;
    rbbi           = this.rbbinfo ;
    rbbi.hwndChild = toolbar.hwnd ;
    sendmsg(RB_INSERTBAND, cast(WPARAM)(-1), cast(LPARAM)(&rbbi) ) ;
    return(0) ;
  }

  int addWindowObject(WindowObject WOBJ){
    REBARBANDINFO rbbi ;
    rbbi           = this.rbbinfo ;
    rbbi.hwndChild = WOBJ.getHWND() ;
    sendmsg(RB_INSERTBAND, cast(WPARAM)(-1), cast(LPARAM)(&rbbi) ) ;
    return(0) ;
  }

}
